"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var metadata_1 = require("./metadata");
var ComposedCallCredentials = /** @class */ (function () {
    function ComposedCallCredentials(creds) {
        this.creds = creds;
    }
    ComposedCallCredentials.prototype.generateMetadata = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var base, generated, _i, generated_1, gen;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        base = new metadata_1.Metadata();
                        return [4 /*yield*/, Promise.all(lodash_1.map(this.creds, function (cred) { return cred.generateMetadata(options); }))];
                    case 1:
                        generated = _a.sent();
                        for (_i = 0, generated_1 = generated; _i < generated_1.length; _i++) {
                            gen = generated_1[_i];
                            base.merge(gen);
                        }
                        return [2 /*return*/, base];
                }
            });
        });
    };
    ComposedCallCredentials.prototype.compose = function (other) {
        return new ComposedCallCredentials(this.creds.concat([other]));
    };
    return ComposedCallCredentials;
}());
var SingleCallCredentials = /** @class */ (function () {
    function SingleCallCredentials(metadataGenerator) {
        this.metadataGenerator = metadataGenerator;
    }
    SingleCallCredentials.prototype.generateMetadata = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.metadataGenerator(options, function (err, metadata) {
                            if (metadata !== undefined) {
                                resolve(metadata);
                            }
                            else {
                                reject(err);
                            }
                        });
                    })];
            });
        });
    };
    SingleCallCredentials.prototype.compose = function (other) {
        return new ComposedCallCredentials([this, other]);
    };
    return SingleCallCredentials;
}());
var EmptyCallCredentials = /** @class */ (function () {
    function EmptyCallCredentials() {
    }
    EmptyCallCredentials.prototype.generateMetadata = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new metadata_1.Metadata()];
            });
        });
    };
    EmptyCallCredentials.prototype.compose = function (other) {
        return other;
    };
    return EmptyCallCredentials;
}());
var CallCredentials;
(function (CallCredentials) {
    /**
     * Creates a new CallCredentials object from a given function that generates
     * Metadata objects.
     * @param metadataGenerator A function that accepts a set of options, and
     * generates a Metadata object based on these options, which is passed back
     * to the caller via a supplied (err, metadata) callback.
     */
    function createFromMetadataGenerator(metadataGenerator) {
        return new SingleCallCredentials(metadataGenerator);
    }
    CallCredentials.createFromMetadataGenerator = createFromMetadataGenerator;
    function createEmpty() {
        return new EmptyCallCredentials();
    }
    CallCredentials.createEmpty = createEmpty;
})(CallCredentials = exports.CallCredentials || (exports.CallCredentials = {}));

//# sourceMappingURL=call-credentials.js.map
