"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("./constants");
var filter_1 = require("./filter");
var units = [['m', 1], ['S', 1000], ['M', 60 * 1000], ['H', 60 * 60 * 1000]];
var DeadlineFilter = /** @class */ (function (_super) {
    __extends(DeadlineFilter, _super);
    function DeadlineFilter(channel, callStream) {
        var _this = _super.call(this) || this;
        _this.channel = channel;
        _this.callStream = callStream;
        var callDeadline = callStream.getDeadline();
        if (callDeadline instanceof Date) {
            _this.deadline = callDeadline.getTime();
        }
        else {
            _this.deadline = callDeadline;
        }
        var now = (new Date()).getTime();
        var timeout = _this.deadline - now;
        if (timeout < 0) {
            timeout = 0;
        }
        if (_this.deadline !== Infinity) {
            setTimeout(function () {
                callStream.cancelWithStatus(constants_1.Status.DEADLINE_EXCEEDED, 'Deadline exceeded');
            }, timeout);
        }
        return _this;
    }
    DeadlineFilter.prototype.sendMetadata = function (metadata) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var timeoutString, finalMetadata, _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!(this.deadline === Infinity)) return [3 /*break*/, 2];
                        return [4 /*yield*/, metadata];
                    case 1: return [2 /*return*/, _d.sent()];
                    case 2:
                        timeoutString = new Promise(function (resolve, reject) {
                            _this.channel.connect(function () {
                                var now = (new Date()).getTime();
                                var timeoutMs = _this.deadline - now;
                                for (var _i = 0, units_1 = units; _i < units_1.length; _i++) {
                                    var _a = units_1[_i], unit = _a[0], factor = _a[1];
                                    var amount = timeoutMs / factor;
                                    if (amount < 1e8) {
                                        resolve(String(Math.ceil(amount)) + unit);
                                        return;
                                    }
                                }
                            });
                        });
                        return [4 /*yield*/, metadata];
                    case 3:
                        finalMetadata = _d.sent();
                        _b = (_a = finalMetadata).set;
                        _c = ['grpc-timeout'];
                        return [4 /*yield*/, timeoutString];
                    case 4:
                        _b.apply(_a, _c.concat([_d.sent()]));
                        return [2 /*return*/, finalMetadata];
                }
            });
        });
    };
    return DeadlineFilter;
}(filter_1.BaseFilter));
exports.DeadlineFilter = DeadlineFilter;
var DeadlineFilterFactory = /** @class */ (function () {
    function DeadlineFilterFactory(channel) {
        this.channel = channel;
    }
    DeadlineFilterFactory.prototype.createFilter = function (callStream) {
        return new DeadlineFilter(this.channel, callStream);
    };
    return DeadlineFilterFactory;
}());
exports.DeadlineFilterFactory = DeadlineFilterFactory;

//# sourceMappingURL=deadline-filter.js.map
